#
# This plugin goes through all Notestudio Pages and removes characters from the
# page name that are not supported by Windows Mobile 5 - bLADEWike
# bLADEWiki release 2.11 currently does not handle / and : characters in the pagename
# 
# Allan Davies
# 


from WikiPlugin import *
from AppData import *
import string
import StringIO
import time
import re
import os
import datetime
from os.path import join


#------------------------------------------------
def tell(message):
	dlg = wxMessageDialog( None, message, "", wxOK)
	ret = dlg.ShowModal()

#------------------------------------------------
def getName():
	#
	# This is the name that appears on the 'plugin' menu.
	# It should be unique
	#
	return "Rename Pages for bLADWWiki compatibility"


def getVendorName():
	#
	# The name of the person who developed the plugin
	#
	return "Dogmelon"


def getVendorVersionString():
	#
	# A version string for this plugin
	#
	return "1.0"


def getDescription():
	#
	# A brief, helpful description of the plugin
	#
	return "This plugin iterates through your pages and renames them where necessary for bLADEWIki compatibility."


def preExecute():
	#
	# Do anything you need to do before running the plugin.
	# This could include popping up a dialog to collect parameters.
	# returns a list of parameters, which will be passed to the execute() method
	#
	STAGE_NAME = "preExecute"
	return []


def execute( parameterList ):

	# Make sure	we are not in edit mode
	if theAppData.editMode == theAppData.MODE_EDIT:
		raise WikiPluginException( "execute", "You must NOT be editing a page" )


	dlg = wxMessageDialog( None, "This plugin rename any pages that have characters incompatible with bLADEWIki Rel 2.11\nAre you sure you want to proceed? ", "Confirm", wxYES_NO | wxICON_QUESTION )
	ret = dlg.ShowModal()

	if ret:
		numBooks = theAppData.library.getNumBooks()
		for b in range(numBooks):
			book = theAppData.library.getBook(b)
			book.initBook()
			numPages = book.getNumPages()
			for i in range( numPages ) :
				page = book.getPage( i )
				pageName = page.getName()
				oldPageName=pageName

				renamepage=False
				# replace any colons with "-" if not in pos 0 otherwise if in pos 0 replace with P-
				
				pos=pageName.find(":",0)
      	# not found or done
				if pos == 0:
					pageName = "P-"+pageName[1:]
					renamepage=True
					#tell(pageName)
				if pos > 0:
					pageName = pageName.replace(":", "-")
					renamepage=True
					#tell(pageName)
				
				# replace any forward slashes with "-"
				pos=pageName.find("/",0)
      	# not found or done
				if pos >= 0:
					renamepage=True
					pageName = pageName.replace("/", "-")
					#tell(pageName)
				
				newPageName=pageName

				if renamepage:
					book.renamePage(oldPageName,pageName)					
				
	dlg = wxMessageDialog( None, "Plugin Finished", "Finished!", wxOK )
	dlg.ShowModal()



		
def postExecute():
	#
	# Do anything you need to clean up after running the plugin.
	#
	STAGE_NAME = "postExecute"
	pass



